local addonName, addon = ...
Reputable = CreateFrame("Frame"), {};

local playerName = UnitName("player")
local server = GetRealmName()
local profileKey = playerName .. "-" .. server
local gender = UnitSex("player");
local level = UnitLevel("player")
local _,playerClass = UnitClass("player")
local playerFaction = UnitFactionGroup("player")
local race = UnitRace("player")

local foundFactions = 0
local repFrame = DEFAULT_CHAT_FRAME

local rewardItemCache = {}

Reputable:SetScript("OnEvent", function (self, event, ...)
	if event == "PLAYER_LOGIN" then
		Reputable:initiate()
	elseif event == "MODIFIER_STATE_CHANGED" then
		local button, state = ...
		if button == "LALT" or button == "RALT" then
			local link = select(2, GameTooltip:GetItem())
			if link then
				local id = tonumber( string.match(link, "item:(%d*)") )
				if Reputable.repitems[ id ] then
					GameTooltip:ClearLines()
					GameTooltip:SetHyperlink(link)
				end
			end
		elseif ( button == "LCTRL" or button == "RCTRL" ) and state == 1 then
			local link = select(2, GameTooltip:GetItem())
			if link then
				local id = tonumber( string.match(link, "item:(%d*)") )
				if Reputable.repitems[ id ] then
				
				--	GameTooltip:ClearLines()
				--	GameTooltip:SetHyperlink(link)
				--	print( "foo", state, id )
				--	print( showRewardTooltip.rewardList )
					if showRewardTooltip.rewardList and showRewardTooltip.rewardMax > 1 then
						showRewardTooltip.rewardShowing = showRewardTooltip.rewardShowing + 1
						if showRewardTooltip.rewardShowing > showRewardTooltip.rewardMax then showRewardTooltip.rewardShowing = 1 end
						
						GetItemInfo( showRewardTooltip.rewardList[showRewardTooltip.rewardShowing] )
					--	GetItemInfo( Reputable.repitems[id].reward[showRewardTooltip.rewardShowing] )
						rewardItemCache[ showRewardTooltip.rewardList[showRewardTooltip.rewardShowing] ] = true
					--	rewardItemCache[ Reputable.repitems[id].reward[showRewardTooltip.rewardShowing] ] = true
						
					--	showRewardTooltip:SetHyperlink("item:"..Reputable.repitems[id].reward[showRewardTooltip.rewardShowing] )
						showRewardTooltip:SetHyperlink("item:"..showRewardTooltip.rewardList[showRewardTooltip.rewardShowing] )
						showRewardTooltip:AddDoubleLine( "Press CTRL to cycle rewards",showRewardTooltip.rewardShowing.."/"..showRewardTooltip.rewardMax )
						showRewardTooltip:Show()
					end
				end
			end
		end
	elseif event == "GET_ITEM_INFO_RECEIVED" then
		local itemID, success = ...
		if success then
			if rewardItemCache[ itemID ] then
				C_Timer.After(0.1, function()
					local link = select(2, GameTooltip:GetItem())
					if link then
						local id = tonumber( string.match(link, "item:(%d*)") )
						if Reputable.repitems[ id ] then
							if showRewardTooltip.rewardList and showRewardTooltip.rewardMax > 1 then
								local needsCycleText = true
								for i = 1, showRewardTooltip:NumLines() do
									if string.find(_G[ "showRewardTooltipTextLeft"..i ]:GetText(),"Press CTRL to cycle rewards") then needsCycleText = false end
								end
								if needsCycleText then
									showRewardTooltip:AddDoubleLine( "Press CTRL to cycle rewards",showRewardTooltip.rewardShowing.."/"..showRewardTooltip.rewardMax )
									showRewardTooltip:Show()
								end
							end
						end
					end
				end )
			end			
		end
	elseif event == "PLAYER_LEVEL_UP" then
		level = ...
		Reputable_Data[profileKey].profile.level = level
	elseif event == "QUEST_TURNED_IN" then
		questID = ...
		if Reputable_Data[profileKey].quests[ questID ] == false then Reputable_Data[profileKey].quests[ questID ] = true end
	end
end)

function Reputable:initiate()
	local defaultData = {
		profileKeys = {},
	--	factionNames = {},
	--	paragonFactions = {},
	}
	if Reputable_Data == nil then
		Reputable_Data = {
			global = defaultData
		}
	end
	for option, default in pairs( defaultData ) do
		if Reputable_Data.global[option] == nil then Reputable_Data.global[option] = default end
	end
	if Reputable_Data.global.profileKeys[profileKey] == nil then Reputable_Data.global.profileKeys[profileKey] = true end
	if Reputable_Data[profileKey] == nil then Reputable_Data[profileKey] = {} end
	Reputable_Data[profileKey].profile = {
											name	= playerName,
											server	= server,
											gender	= gender,
											level	= level,
											class	= playerClass,
											faction	= playerFaction,
										}
	
	--C_Timer.After(5, function() Reputable:UpdateData() end ) -- Delays data grab on login (in seconds). Unnecessary?
	Reputable:getAllFactions( true )
	
	if Reputable_Data[profileKey].quests == nil then Reputable_Data[profileKey].quests = {} end
	for k,v in pairs( Reputable.repitems ) do
		if v.quest and not v.repeatable then
			local questID
			if type(v.quest) == 'table' then
				if v.quest[ playerClass ] then
					questID = v.quest[ playerClass ].questID
				end
			else
				questID = v.quest
			end
			if questID then
			--	table.insert(Reputable.quests, questID)
			--	print( questID )
				Reputable_Data[profileKey].quests[ questID ] = IsQuestFlaggedCompleted( questID )
			end
		end
	end
end


SLASH_REPUTABLE1= "/reputable";
function SlashCmdList.REPUTABLE(msg)
	--for i,v in ipairs( Reputable.quests ) do
	for i,v in pairs( Reputable_Data[profileKey].quests ) do
		print( i,v )
	end
end


local function getRepString( repValue, profile )
	local repString = { str = "|cffffd100-" }
	local standingID
	local standingLabel
	local dispValue = repValue
	local progress
	if repValue then
		if repValue < -6000 then
			standingID = 1
			dispValue = repValue + 42000
		elseif repValue < -3000 then
			standingID = 2
			dispValue = repValue + 6000
		elseif repValue < 0 then
			dispValue = repValue + 3000
			standingID = 3
		elseif repValue < 3000 then
			standingID = 4
		elseif repValue < 9000 then
			standingID = 5
			dispValue = repValue - 3000
		elseif repValue < 21000 then
			standingID = 6
			dispValue = repValue - 9000
		elseif repValue < 42000 then
			standingID = 7
			dispValue = repValue - 21000
		elseif repValue >= 42000 then
			standingID = 8
			progress = ""
		--else
		--	standingID = 9
		--	dispValue = ( repValue - 42000 ) % 10000
		--	standingLabel = Reputable.factionStandingColours[9] .. "Paragon"
		end
		--if standingID < 9 then
			standingLabel = Reputable.factionStandingColours[standingID] .. GetText("FACTION_STANDING_LABEL"..standingID, profile.gender)
		--end
		if standingID ~= 8 then
			progress = " " .. math.floor( dispValue/100 ) / 10 .. "k /" .. Reputable.factionStandingMax[standingID]/1000 .. "k"
		end
			
	--	print(standingID,Reputable.factionStandingColours[standingID] ,GetText("FACTION_STANDING_LABEL"..standingID, profile.gender))
		repString = {
			str = standingLabel .. progress,
			l = standingLabel,
			n = progress,
			s = standingID,			
		}
	end
	--local factionStandingtext = Reputable.factionStandingColours[standingNew.standingID] .. GetText("FACTION_STANDING_LABEL"..standingNew.standingID, gender);
	
	return repString
end

local showRewardTooltip = CreateFrame("GameTooltip", "showRewardTooltip", GameTooltip, "GameTooltipTemplate")

--local function addRepToToolTip( self, item, itemMinLevel )
local function addRepToToolTip( self, id )
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemIcon,
		itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo( id )
	

	
	local item = Reputable.repitems[ id ]
	local factionID = item.faction
	if type(factionID) == 'table' then factionID = item.faction[ playerFaction ] end
	--print(factionID)
	if itemMinLevel == nil then itemMinLevel = 0 end
	if item.level then itemMinLevel = item.level end
	local requiredStanding = ""
	if item.requires then
		local limit = ""
		if item.limit then limit = " to " .. Reputable.factionStandingColours[item.limit] .. GetText("FACTION_STANDING_LABEL"..item.limit, gender).."\124r\n" end
		requiredStanding = "Requires "..Reputable.factionStandingColours[item.requires] .. GetText("FACTION_STANDING_LABEL"..item.requires, gender).."\124r"..limit.."\n"
	end
	--standingLabel = Reputable.factionStandingColours[standingID] .. GetText("FACTION_STANDING_LABEL"..standingID, profile.gender)
	local factionName,_,factionStanding,barMin,barMax,value = GetFactionInfoByID( factionID );
	local multiplier = 1
	if race == "Human" then multiplier = 1.1 end
	local token = ""
	if item.token then token = " + " .. Reputable.repitems[ item.token ].rep * multiplier end
	local stack = ""
	if item.stack then stack = " (per " .. item.stack .. ")" end
	local itemrep = ""
	if item.rep then  itemrep = item.rep * multiplier end
	--itemrep = itemrep * multiplier
	local repIncrease = ""
	if itemrep or token then repIncrease = ": ".. itemrep .. token .. stack end
	local factionHeader = "|cffffd100" .. factionName .. repIncrease
	local factionStandingtext = "|cffffd100Faction not encountered yet"
	if Reputable_Data[profileKey].factions[factionID] then
		local reputationString = getRepString( Reputable_Data[profileKey].factions[factionID], Reputable_Data[profileKey].profile )
		factionStandingtext = reputationString.str
	end
	if _G[ self:GetName().."TextLeft2" ]:GetText() then
		_G[ self:GetName().."TextLeft2" ]:SetText( factionHeader.."\124r\n"..factionStandingtext.."\124r\n"..requiredStanding.._G[ self:GetName().."TextLeft2" ]:GetText())
	else
		self:AddLine( factionHeader.."\124r\n"..factionStandingtext.."\124r\n"..requiredStanding )
	end

	local itemRewards = item.reward
	local classRewards = false
	local soulbound = false
	local startsquest = false
	for i = 1, self:NumLines() do
		if string.find(_G[ self:GetName().."TextLeft"..i ]:GetText(),ITEM_SOULBOUND) then soulbound = true end
		if string.find(_G[ self:GetName().."TextLeft"..i ]:GetText(),ITEM_STARTS_QUEST) then startsquest = i end
	end
	if item.quest then
		local questID
		if type(item.quest) == 'table' then
			classRewards = true
			if item.quest[ playerClass ] then
				questID = item.quest[ playerClass ].questID
				itemRewards = item.quest[ playerClass ].reward
			end
		else
			questID = item.quest
		end
		if questID then
			--print("This item starts quest", startsquest)
			local questStatus = "Incomplete"
			if item.repeatable then
				questStatus = "Repeatable"
		--	elseif IsQuestFlaggedCompleted( questID ) then
			elseif Reputable_Data[profileKey].quests[ questID ] then
				questStatus = "Completed"
			end
			if startsquest then
				_G[ self:GetName().."TextLeft"..startsquest ]:SetText(_G[ self:GetName().."TextLeft"..startsquest ]:GetText().. " (" .. questStatus .. ")")
			elseif _G[ self:GetName().."TextLeft3" ]:GetText() then
				_G[ self:GetName().."TextLeft3" ]:SetText( _G[ self:GetName().."TextLeft3" ]:GetText().." ("..questStatus..")")
			end
		end
	end
	--	if string.find(_G[ self:GetName().."TextLeft"..i ]:GetText(),ITEM_BNETACCOUNTBOUND) and IsAltKeyDown() then
	--	if string.find(_G[ self:GetName().."TextLeft"..i ]:GetText(),ITEM_BNETACCOUNTBOUND) or string.find(_G[ self:GetName().."TextLeft"..i ]:GetText(),ITEM_BIND_TO_BNETACCOUNT) then
	--		for k,v in pairs( WorldQuestTipsData ) do
	--if not soulbound then
	--if soulbound then
			for key,show in pairs( Reputable_Data.global.profileKeys ) do
	--			if k ~= "global" and k ~= "version" and k ~= profileKey then
				if key ~= profileKey then
		--			print( k,v )
					local k  = Reputable_Data[key]
					if show then 
				--		print( key, k.factions[factionID] )
					end
					if 	k.profile and server == k.profile.server and not item[ k.profile.faction ] then
					--	print( k.profile.name, 
						local reputationString = getRepString( k.factions[factionID], k.profile )
				--	if v.info and v.info.level > 100 then
						local color = RAID_CLASS_COLORS[k.profile.class]
						local level = ""
						if k.profile.level < itemMinLevel then level = "|cff808080 ("..k.profile.level..")" end
						
						local rewardForThisClass = true
						if classRewards and not item.quest[ k.profile.class ] then rewardForThisClass = false end
						
						local complete = ""
						local questForThisAlt = false
					--	local thisQuestId = item.quest[ k.profile.class ].questID or item.quest
						local thisQuestId
						if classRewards then
							if item.quest[ k.profile.class ] then thisQuestId = item.quest[ k.profile.class ].questID end
							else thisQuestId = item.quest
						end
						if thisQuestId then
							--print( thisQuestId )
							questForThisAlt = true
							complete = "|cff808080 (Incomplete)"
						--	print( k.profile.name, k.quests[ thisQuestId ] )
							if k.quests[ thisQuestId ] then complete = "|cffffffff (Complete)" end
							if k.quests[ thisQuestId ] == nil then complete = "|cff808080 (Unknown)" end
						end
						
				--		if not ( string.find( v.reps[ factionID ], "|cff808080" ) and not WorldQuestTipsData.global.options.showExalted ) then
				--			self:AddDoubleLine( k.profile.name..level, k.factions[factionID], color.r, color.g, color.b )
				--			self:AddDoubleLine( k.profile.name..level, reputationString.str, color.r, color.g, color.b )
						if ( k.profile.level >= itemMinLevel and ( rewardForThisClass or questForThisAlt ) ) or IsAltKeyDown() then self:AddDoubleLine( k.profile.name..level..complete, reputationString.str, color.r, color.g, color.b ) end
				--		end
					end
				end
			end
	--	end
	--end
--	end

	if Reputable.repitemsets[ id ] then
		self:AddLine( " " )
		self:AddLine( "Set:" )
	--	print( Reputable.repitemsets[ id ][1], table.getn( Reputable.repitemsets[ id ] ) )
		for i,v in ipairs( Reputable.repitemsets[ id ] ) do
			local thisItemLink = select( 2, GetItemInfo( Reputable.repitemsets[ id ][i] ) )
			local note = ""
			if Reputable.repitemsets[ id ].note then note = Reputable.repitemsets[ id ].note[i] end
			
			local countBags = GetItemCount(Reputable.repitemsets[ id ][i])
			local countTotal = GetItemCount(Reputable.repitemsets[ id ][i], true)
			local bankText = ""
			if countTotal - countBags ~= 0 then bankText = "(".. (countTotal - countBags) .. " in bank) " end
		--	print("Netherweave Cloth:", countBags, "(bags)", (countTotal - countBags), "(bank)")
		--	print( Reputable.repitemsets[ id ][i], thisItemLink,":", countTotal .. " (".. (countTotal - countBags) .. " in bank)")
			self:AddDoubleLine( thisItemLink.." "..note, bankText .. countTotal )
		end		
	end

	self:Show()
	
	showRewardTooltip.rewardList = nil
		
	--if item.reward then
	if itemRewards then

		showRewardTooltip.rewardList = itemRewards
		showRewardTooltip.rewardShowing = showRewardTooltip.rewardShowing or 1
		showRewardTooltip.rewardMax = table.getn(itemRewards)
		
		if showRewardTooltip.rewardShowing > showRewardTooltip.rewardMax then showRewardTooltip.rewardShowing = 1 end
		
		GetItemInfo( itemRewards[showRewardTooltip.rewardShowing] )
		rewardItemCache[ itemRewards[showRewardTooltip.rewardShowing] ] = true
		
		showRewardTooltip:SetOwner(GameTooltip, "ANCHOR_NONE")
		showRewardTooltip:SetHyperlink("item:"..itemRewards[showRewardTooltip.rewardShowing] )
		--showRewardTooltip:AddLine( table.getn(itemRewards) )
		--showRewardTooltip:AddLine( showRewardTooltip.rewardShowing )
		--		showRewardTooltip:Show()
		if showRewardTooltip.rewardMax > 1 then
			showRewardTooltip:AddDoubleLine( "Press CTRL to cycle rewards",showRewardTooltip.rewardShowing.."/"..showRewardTooltip.rewardMax )
		end
	--	showRewardTooltip:Show()
		
		
		--print( GetScreenWidth() )
		--print( showRewardTooltip:GetWidth() )
		--print( GetScreenWidth()-self:GetRight() )
		--print( playerClass )
		local screenW = GetScreenWidth() or 0
		local ttW = showRewardTooltip:GetWidth() or 0
		local ttR = self:GetRight() or 0
	--if screenW and ttR then
	
	--print( screenW, ttW, ttR )
		if screenW - ttR < ttW then
			showRewardTooltip:ClearAllPoints()
			showRewardTooltip:SetPoint("TOPRIGHT",GameTooltip,"TOPLEFT",0,0);
		else
			showRewardTooltip:ClearAllPoints()
			showRewardTooltip:SetPoint("TOPLEFT",GameTooltip,"TOPRIGHT",0,0);
		end
	--end
	
		showRewardTooltip:Show()
	--	for k,v in pairs ( showRewardTooltip ) do
	--		print( k,v)
	--	end
	end
end

hooksecurefunc(ItemRefTooltip, "SetHyperlink", function(self, link )
	--local type, id = tonumber( string.match(link,"^(%a+):(%d+)") )
	local id = tonumber( string.match(link, "item:(%d*)") )
	--if type == "item" and Reputable.repitems[ id ] then
	if id and Reputable.repitems[ id ] then
		if Reputable.repitems[ id ][ playerFaction ] then id = Reputable.repitems[ id ][ playerFaction ] end
	--	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemIcon,
	--	itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo( id )
	--	addRepToToolTip( self, Reputable.repitems[ id ], itemMinLevel )
		addRepToToolTip( self, id )
	end
end)


GameTooltip:HookScript("OnTooltipSetItem", function(self)
	local link = select(2, self:GetItem())
	if link then
		--print( link )
		local id = tonumber( string.match(link, "item:(%d*)") )
		if id and Reputable.repitems[ id ] then
			if Reputable.repitems[ id ][ playerFaction ] then id = Reputable.repitems[ id ][ playerFaction ] end
		--	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemIcon,
		--	itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo( id )
		--	addRepToToolTip( self, Reputable.repitems[ id ], itemMinLevel )
			addRepToToolTip( self, id )
		end
	end
end)






local Reputable_msg_filter = function(frame, event, message, ...)
	repFrame = frame
	--Reputable:getAllFactions()
	C_Timer.After(0.2, function() Reputable:getAllFactions() end )
	return true
end
ChatFrame_AddMessageEventFilter("CHAT_MSG_COMBAT_FACTION_CHANGE", Reputable_msg_filter)

function Reputable:createRepString( faction )
	local factionStandingtext = Reputable.factionStandingColours[faction.standingID] .. GetText("FACTION_STANDING_LABEL"..faction.standingID, gender);
	local changeString = ""
	if faction.oldValue then
		local positive = "+"
		local change = faction.barValue - faction.oldValue
		if change < 0 then positive = "" end
		changeString = positive .. change
	end
	
	local newmessage = "Reputable: " .. faction.name .. " " .. changeString .. " ("..factionStandingtext .. " " .. faction.barValue - faction.barMin .. " /" .. faction.barMax - faction.barMin .. "|r)"

	getglobal(repFrame:GetName()):AddMessage(newmessage,0.5,0.5,1)	
end

function Reputable:getAllFactions( initiate )

	if Reputable_Data[profileKey].factions == nil then Reputable_Data[profileKey].factions = {} end
	
	local numFactions = GetNumFactions()
	for factionIndex = 1, numFactions do
		local name, description, standingId, barMin, barMax, earnedValue, atWarWith, canToggleAtWar,
			isHeader, isCollapsed, hasRep, isWatched, isChild, factionID, hasBonusRepGain, canBeLFGBonus = GetFactionInfo(factionIndex)
		if isHeader and isCollapsed then
			ExpandFactionHeader(factionIndex)
			numFactions = GetNumFactions()
		end
			
		if hasRep or not isHeader then
			
			if initiate then
				Reputable_Data[profileKey].factions[ factionID ] = earnedValue
			else
				local oldValue = Reputable_Data[profileKey].factions[ factionID ]
				if earnedValue ~= oldValue then
					local faction = {
						factionID = factionID,
						name = name,
						standingID = standingId,
						barMin = barMin,
						barMax = barMax,
						barValue = earnedValue,
						oldValue = oldValue,
					}
					Reputable_Data[profileKey].factions[ factionID ] = earnedValue
					
					Reputable:createRepString( faction )
				end
			end
		end
	end
end

-- Register Initial Events
Reputable:RegisterEvent("PLAYER_LOGIN")
Reputable:RegisterEvent("MODIFIER_STATE_CHANGED")
Reputable:RegisterEvent("PLAYER_LEVEL_UP")
Reputable:RegisterEvent("GET_ITEM_INFO_RECEIVED")
Reputable:RegisterEvent("QUEST_TURNED_IN")
